/*
**	Stamper DLL Header
**		version 1.10.1
**
** Copyright(c)2022 ЃgXgE\tgEFAEVXe
*/

#pragma once

#include <Windows.h>

#define MLPAPI __declspec(dllimport)
#ifdef	WINAPI
#undef	WINAPI
#endif
#define	WINAPI	__stdcall

#include "MlpError.h"
#include "MlpDeclaration.h"

#ifdef	_UNICODE
#define	MlpInitialize			MlpInitializeW
#define	MlpAddLicense			MlpAddLicenseW
#define	MlpLicenseInfoStr		MlpLicenseInfoStrW
#define	MlpGetLicenseInfo		MlpGetLicenseInfoW
#define	MlpLoadInitFile			MlpLoadInitFileW
#define	MlpLoadInitData			MlpLoadInitDataW
#define	MlpOpenDoc0				MlpOpenDoc0W
#define	MlpOpenDoc				MlpOpenDocW
#define	MlpOpenMemDoc0			MlpOpenMemDoc0W
#define	MlpOpenMemDoc			MlpOpenMemDocW
#define	MlpOpenMemDocUsage		MlpOpenMemDocUsageW
#define	MlpCreatePict			MlpCreatePictW
#define	MlpCreatePictData		MlpCreatePictDataW
#define	MlpPageToPict			MlpPageToPictW
#define	MlpConvertToTiff		MlpConvertToTiffW
#define	MlpConvertToTiff		MlpConvertToTiffW
#define	MlpCreateTiffMulti		MlpCreateTiffMultiW
#define	MlpRangeToTiff			MlpRangeToTiffW
#define	MlpMultiPageToTiff		MlpMultiPageToTiffW
#define MlpCreatePDF			MlpCreatePDFW
#define MlpCreatePDFFile		MlpCreatePDFFileW
#define MlpCreatePDFArray		MlpCreatePDFArrayW
#define	MlpSetRGBProfile		MlpSetRGBProfileW
#define	MlpSetCMYKProfile		MlpSetCMYKProfileW
#define	MlpSetGrayProfile		MlpSetGrayProfileW
#define MlpSetDefaultFont		MlpSetDefaultFontW
#define	MlpSetStampFile			MlpSetStampFileW
#define	MlpSetStampData			MlpSetStampDataW
#define	MlpPaintStampFile		MlpPaintStampFileW
#define	MlpPaintStampData		MlpPaintStampDataW
#define	MlpPaintStampName		MlpPaintStampNameW
#define	MlpPaintStampNamePos	MlpPaintStampNamePosW
#define	MlpSavePDF				MlpSavePDFW
#else
#define	MlpInitialize			MlpInitializeA
#define	MlpAddLicense			MlpAddLicenseA
#define	MlpLicenseInfoStr		MlpLicenseInfoStrA
#define	MlpGetLicenseInfo		MlpGetLicenseInfoA
#define	MlpLoadInitFile			MlpLoadInitFileA
#define	MlpLoadInitData			MlpLoadInitDataA
#define	MlpOpenDoc0				MlpOpenDoc0A
#define	MlpOpenDoc				MlpOpenDocA
#define	MlpOpenMemDoc0			MlpOpenMemDoc0A
#define	MlpOpenMemDoc			MlpOpenMemDocA
#define	MlpOpenMemDocUsage		MlpOpenMemDocUsageA
#define	MlpCreatePictData		MlpCreatePictDataA
#define	MlpPageToPict			MlpPageToPictA
#define	MlpConvertToTiff		MlpConvertToTiffA
#define	MlpCreateTiffRange		MlpCreateTiffRangeA
#define	MlpCreateTiffMulti		MlpCreateTiffMultiA
#define	MlpRangeToTiff			MlpRangeToTiffA
#define	MlpMultiPageToTiff		MlpMultiPageToTiffA
#define MlpCreatePDF			MlpCreatePDFA
#define MlpCreatePDFFile		MlpCreatePDFFileA
#define MlpCreatePDFArray		MlpCreatePDFArrayA
#define	MlpCreatePict			MlpCreatePictA
#define	MlpSetRGBProfile		MlpSetRGBProfileA
#define	MlpSetCMYKProfile		MlpSetCMYKProfileA
#define	MlpSetGrayProfile		MlpSetGrayProfileA
#define	MlpMlpSetStampFile		MlpMlpSetStampFileA
#define	MlpMlpSetStampData		MlpMlpSetStampDataA
#define	MlpSetStampFile			MlpSetStampFileA
#define	MlpSetStampData			MlpSetStampDataA
#define	MlpPaintStampFile		MlpPaintStampFileA
#define	MlpPaintStampData		MlpPaintStampDataA
#define	MlpPaintStampName		MlpPaintStampNameA
#define	MlpPaintStampNamePos	MlpPaintStampNamePosA
#define	MlpSavePDF				MlpSavePDFA
#endif

#ifdef	__cplusplus
extern "C" {
#endif

/**/
MLPAPI int WINAPI MlpInitializeA(const char *license);
MLPAPI int WINAPI MlpInitializeW(const wchar_t *license);
MLPAPI void WINAPI MlpUninitialize();
MLPAPI int WINAPI MlpAddLicenseA(const char *license);

/*f[^*/
MLPAPI int WINAPI MlpLoadInitFileW(const wchar_t *fileName);
MLPAPI int WINAPI MlpLoadInitFileA(const char *fileName);
MLPAPI int WINAPI MlpLoadInitDataW(const wchar_t *data, int len);
MLPAPI int WINAPI MlpLoadInitDataA(const char *data, int len);

/*CZX*/
MLPAPI void WINAPI MlpShowLicenseInfo();
MLPAPI int WINAPI MlpLicenseInfoStrA(char *licenseStrPtr, int length);
MLPAPI int WINAPI MlpLicenseInfoStrW(wchar_t *licenseStrPtr, int length);
MLPAPI char* WINAPI MlpGetLicenseInfoA();
MLPAPI wchar_t* WINAPI MlpGetLicenseInfoW();


/*I[v*/
MLPAPI int WINAPI MlpOpenDoc0W(const wchar_t *fileName, const wchar_t *ownerPassword, const wchar_t *userPassword);
MLPAPI int WINAPI MlpOpenDoc0A(const char *fileName, const char *ownerPassword, const char *userPassword);
MLPAPI int WINAPI MlpOpenDocW(const wchar_t *fileName, const wchar_t *password);
MLPAPI int WINAPI MlpOpenDocA(const char *fileName, const char *password);
MLPAPI int WINAPI MlpOpenNewDoc(float width, float height, int rotate, void*);
MLPAPI int WINAPI MlpOpenMemDoc0W(unsigned char *data, size_t length, const wchar_t *owner_pw, const wchar_t *user_pw);
MLPAPI int WINAPI MlpOpenMemDoc0A(unsigned char *data, size_t length, const char *owner_pw, const char *user_pw);
MLPAPI int WINAPI MlpOpenMemDocW(unsigned char *data, size_t length, const wchar_t *pswd);
MLPAPI int WINAPI MlpOpenMemDocA(unsigned char *data, size_t length, const char *pswd);
MLPAPI void WINAPI MlpCloseDoc();

/*Cu*/
MLPAPI int __stdcall MlpGetLibraryInfo(int cmd, ...);

/**/
MLPAPI int WINAPI MlpGetDocumentInfo(int cmd, ...);
MLPAPI int WINAPI MlpPageCount();
MLPAPI int WINAPI MlpGetPageRotation(int pageNum, int *rotate);
MLPAPI int WINAPI MlpGetPageBoundary(int pageNum, int kind, float *userUnit, float *left, float *bottom, float *right, float *top);
MLPAPI int WINAPI MlpGetPageRawBoundary(int pageNum, int kind, float *userUnit, float *left, float *bottom, float *right, float *top);
MLPAPI int WINAPI MlpGetPicturePixel(int pageNum, int *x, int *y);
MLPAPI int WINAPI MlpGetPicturePixelX(int pageNum);
MLPAPI int WINAPI MlpGetPicturePixelY(int pageNum);

/*ݒ*/
MLPAPI int WINAPI MlpSetPicture(int opt, ...);
MLPAPI int WINAPI MlpSetPictureSize(int x, int y, int unit);
MLPAPI int WINAPI MlpSetPictureResolution(int dpi);
MLPAPI int WINAPI MlpSetPictureQuality(int quality);
MLPAPI int WINAPI MlpSetPicturePixelX(int x);
MLPAPI int WINAPI MlpSetPicturePixelY(int y);
MLPAPI int WINAPI MlpSetPicturePixelXY(int x, int y);
MLPAPI int WINAPI MlpSetCanvasSize(int x, int y);
MLPAPI int WINAPI MlpSetCanvasOrigin(int org);
MLPAPI int WINAPI MlpSetTiffCompress(int mode);
MLPAPI int WINAPI MlpSetEnableAntialis();
MLPAPI int WINAPI MlpSetDisableAntialis();
MLPAPI int WINAPI MlpSetFillPathAAEnable();
MLPAPI int WINAPI MlpSetFillPathAADisable();
MLPAPI int WINAPI MlpSetCid0GlyphMode(int mode);

/*F*/
MLPAPI int WINAPI MlpSetPictureRGB();
MLPAPI int WINAPI MlpSetPictureCMYK();
MLPAPI int WINAPI MlpSetPictureGray();
MLPAPI int WINAPI MlpSetPictureBW();
MLPAPI int WINAPI MlpSetPictureDither();

/*J[vt@C*/
MLPAPI int WINAPI MlpUseCMS();
MLPAPI int WINAPI MlpUnuseCMS();
MLPAPI int WINAPI MlpSetRGBProfileW(const wchar_t *fileName);
MLPAPI int WINAPI MlpSetRGBProfileA(const char *fileName);
MLPAPI int WINAPI MlpSetCMYKProfileW(const wchar_t *fileName);
MLPAPI int WINAPI MlpSetCMYKProfileA(const char *fileName);
MLPAPI int WINAPI MlpSetGrayProfileW(const wchar_t *fileName);
MLPAPI int WINAPI MlpSetGrayProfileA(const char *fileName);

/*摜*/
MLPAPI int WINAPI MlpCreatePictW(int pageNumber, const wchar_t *outputFilePath);
MLPAPI int WINAPI MlpCreatePictA(int pageNumber, const char *outputFilePath);

/*X^v*/
MLPAPI int WINAPI MlpSetStampFileA(char *filePath);
MLPAPI int WINAPI MlpSetStampFileW(wchar_t *filePath);
MLPAPI int WINAPI MlpSetStampDataA(char* data, unsigned int length);
MLPAPI int WINAPI MlpSetStampDataW(wchar_t* data, unsigned int length);
MLPAPI int WINAPI MlpPaintStamp();
MLPAPI int WINAPI MlpPaintStampFileA(char *filePath);
MLPAPI int WINAPI MlpPaintStampFileW(wchar_t *filePath);
MLPAPI int WINAPI MlpPaintStampDataA(char* data, unsigned int length);
MLPAPI int WINAPI MlpPaintStampDataW(wchar_t* data, unsigned int length);
MLPAPI int WINAPI MlpPaintStampNameA(char *name);
MLPAPI int WINAPI MlpPaintStampNameW(wchar_t *name);
MLPAPI int WINAPI MlpPaintStampNamePosA(char *name, float x_pos, float y_pos);
MLPAPI int WINAPI MlpPaintStampNamePosW(wchar_t *name, float x_pos, float y_pos);
MLPAPI int WINAPI MlpClearStampBoundary();
MLPAPI int WINAPI MlpGetStampBoundary(float *x_pos, float *y_pos, float *width, float *height);

/*PDFf[^*/
MLPAPI int WINAPI MlpRemoveMetadata();
MLPAPI int WINAPI MlpSavePDFA(char *filePath);
MLPAPI int WINAPI MlpSavePDFW(wchar_t *filePath);

#ifdef	__cplusplus
}
#endif
