/*
**	PdfStructure DLL Header
**		version 1.10.1
**
** Copyright(c) 2022 ЃgXgE\tgEFAEVXe
*/

#pragma once

#include <Windows.h>

#define MLPAPI __declspec(dllimport)
#ifdef	WINAPI
#undef	WINAPI
#endif
#define	WINAPI	__stdcall

#include "MlpError.h"
#include "MlpDeclaration.h"

#ifdef	_UNICODE
#define	MlpInitialize			MlpInitializeW
#define	MlpAddLicense			MlpAddLicenseW
#define	MlpLicenseInfoStr		MlpLicenseInfoStrW
#define	MlpGetLicenseInfo		MlpGetLicenseInfoW
#define	MlpLoadInitFile			MlpLoadInitFileW
#define	MlpLoadInitData			MlpLoadInitDataW
#define	MlpOpenDoc				MlpOpenDocW
#define	MlpOpenDocUsage			MlpOpenDocUsageW
#define	MlpValidateOwnerPassword	MlpValidateOwnerPasswordW
#define	MlpValidateUserPassword		MlpValidateUserPasswordW
#define	MlpOpenMemDoc			MlpOpenMemDocW
#define	MlpOpenMemDocUsage		MlpOpenMemDocUsageW
#define	MlpSetImageWatermark	MlpSetImageWatermarkW
#define	MlpSetFillTextWatermark	MlpSetFillTextWatermarkW
#define	MlpSetStrokeTextWatermark	MlpSetStrokeTextWatermarkW
#define	MlpCreatePict			MlpCreatePictW
#define	MlpCreatePictData		MlpCreatePictDataW
#define	MlpPageToPict			MlpPageToPictW
#define	MlpConvertToTiff		MlpConvertToTiffW
#define	MlpCreateTiffRange		MlpCreateTiffRangeW
#define	MlpCreateTiffMulti		MlpCreateTiffMultiW
#define	MlpRangeToTiff			MlpRangeToTiffW
#define	MlpMultiPageToTiff		MlpMultiPageToTiffW
#define MlpCreatePDF			MlpCreatePDFW
#define MlpCreatePDFFile		MlpCreatePDFFileW
#define MlpCreatePDFArray		MlpCreatePDFArrayW
#define MlpAddToPDF				MlpAddToPDFW
#define	MlpSetRGBProfile		MlpSetRGBProfileW
#define	MlpSetCMYKProfile		MlpSetCMYKProfileW
#define	MlpSetGrayProfile		MlpSetGrayProfileW
#define MlpSetDefaultFont		MlpSetDefaultFontW
#define MlpSetAlternateFont		MlpSetAlternateFontW
#define MlpSetAlternateFont2	MlpSetAlternateFont2W
#define MlpSetAlternateFontEx	MlpSetAlternateFontExW
#define	MlpPanelToFile			MlpPanelToFileW
#define	MlpPaintRectToPanel2	MlpPaintRectToPanel2W
#define	MlpSetStampFile			MlpSetStampFileW
#define	MlpSetStampData			MlpSetStampDataW
#define	MlpPaintStampFile		MlpPaintStampFileW
#define	MlpPaintStampData		MlpPaintStampDataW
#define	MlpPaintStampName		MlpPaintStampNameW
#define	MlpPaintStampNamePos	MlpPaintStampNamePosW
#define	MlpSavePDF				MlpSavePDFW
#else
#define	MlpInitialize			MlpInitializeA
#define	MlpAddLicense			MlpAddLicenseA
#define	MlpLicenseInfoStr		MlpLicenseInfoStrA
#define	MlpGetLicenseInfo		MlpGetLicenseInfoA
#define	MlpLoadInitFile			MlpLoadInitFileA
#define	MlpLoadInitData			MlpLoadInitDataA
#define	MlpOpenDoc				MlpOpenDocA
#define	MlpOpenDocUsage			MlpOpenDocUsageA
#define	MlpValidateOwnerPassword	MlpValidateOwnerPasswordA
#define	MlpValidateUserPassword		MlpValidateUserPasswordA
#define	MlpOpenMemDoc			MlpOpenMemDocA
#define	MlpOpenMemDocUsage		MlpOpenMemDocUsageA
#define	MlpSetImageWatermark	MlpSetImageWatermarkA
#define	MlpSetFillTextWatermark	MlpSetFillTextWatermarkA
#define	MlpSetStrokeTextWatermark	MlpSetStrokeTextWatermarkA
#define	MlpCreatePict			MlpCreatePictA
#define	MlpCreatePictData		MlpCreatePictDataA
#define	MlpPageToPict			MlpPageToPictA
#define	MlpConvertToTiff		MlpConvertToTiffA
#define	MlpCreateTiffRange		MlpCreateTiffRangeA
#define	MlpCreateTiffMulti		MlpCreateTiffMultiA
#define	MlpRangeToTiff			MlpRangeToTiffA
#define	MlpMultiPageToTiff		MlpMultiPageToTiffA
#define MlpCreatePDF			MlpCreatePDFA
#define MlpCreatePDFFile		MlpCreatePDFFileA
#define MlpCreatePDFArray		MlpCreatePDFArrayA
#define MlpAddToPDF				MlpAddToPDFA
#define	MlpSetRGBProfile		MlpSetRGBProfileA
#define	MlpSetCMYKProfile		MlpSetCMYKProfileA
#define	MlpSetGrayProfile		MlpSetGrayProfileA
#define MlpSetDefaultFont		MlpSetDefaultFontA
#define MlpSetAlternateFont		MlpSetAlternateFontA
#define MlpSetAlternateFont2	MlpSetAlternateFont2A
#define MlpSetAlternateFontEx	MlpSetAlternateFontExA
#define	MlpPanelToFile			MlpPanelToFileA
#define	MlpPaintRectToPanel2	MlpPaintRectToPanel2A
#define	MlpSetStampFile			MlpSetStampFileA
#define	MlpSetStampData			MlpSetStampDataA
#define	MlpPaintStampFile		MlpPaintStampFileA
#define	MlpPaintStampData		MlpPaintStampDataA
#define	MlpPaintStampName		MlpPaintStampNameA
#define	MlpPaintStampNamePos	MlpPaintStampNamePosA
#define	MlpSavePDF				MlpSavePDFA
#endif

#ifdef	__cplusplus
extern "C" {
#endif

/**/
MLPAPI int WINAPI MlpInitializeA(const char *license);
MLPAPI int WINAPI MlpInitializeW(const wchar_t *license);
MLPAPI void WINAPI MlpUninitialize();
MLPAPI int WINAPI MlpAddLicenseA(const char *license);

/*CZX*/
MLPAPI void WINAPI MlpShowLicenseInfo();
MLPAPI int WINAPI MlpLicenseInfoStrA(char *licenseStrPtr, int length);
MLPAPI char* WINAPI MlpGetLicenseInfoA();
MLPAPI wchar_t* WINAPI MlpGetLicenseInfoW();

/*f[^*/
MLPAPI int WINAPI MlpLoadInitFileW(const wchar_t *fileName);
MLPAPI int WINAPI MlpLoadInitFileA(const char *fileName);
MLPAPI int WINAPI MlpLoadInitDataW(const wchar_t *data, int len);
MLPAPI int WINAPI MlpLoadInitDataA(const char *data, int len);

/*I[v*/
MLPAPI int WINAPI MlpOpenDoc0W(const wchar_t *fileName, const wchar_t *ownerPassword, const wchar_t *userPassword);
MLPAPI int WINAPI MlpOpenDoc0A(const char *fileName, const char *ownerPassword, const char *userPassword);
MLPAPI int WINAPI MlpOpenDocW(const wchar_t *fileName, const wchar_t *password);
MLPAPI int WINAPI MlpOpenDocA(const char *fileName, const char *password);
MLPAPI int WINAPI MlpOpenNewDoc(float width, float height, int rotate, void*);
MLPAPI int WINAPI MlpOpenDocUsageW(const wchar_t *fileName, const wchar_t *password, int usage);
MLPAPI int WINAPI MlpOpenDocUsageA(const char *fileName, const char *password, int usage);
MLPAPI int WINAPI MlpOpenMemDoc0W(unsigned char *data, size_t length, const wchar_t *owner_pw, const wchar_t *user_pw);
MLPAPI int WINAPI MlpOpenMemDoc0A(unsigned char *data, size_t length, const char *owner_pw, const char *user_pw);
MLPAPI int WINAPI MlpOpenMemDocW(unsigned char *data, size_t length, const wchar_t *password);
MLPAPI int WINAPI MlpOpenMemDocA(unsigned char *data, size_t length, const char *password);
MLPAPI int WINAPI MlpOpenMemDocUsageW(unsigned char *data, size_t len, const wchar_t *password, int usage);
MLPAPI int WINAPI MlpOpenMemDocUsageA(unsigned char *data, size_t len, const char *password, int usage);
MLPAPI void WINAPI MlpCloseDoc();

/*Cu*/
MLPAPI int __stdcall MlpGetLibraryInfo(int cmd, ...);

/**/
MLPAPI int WINAPI MlpGetDocumentInfo(int cmd, ...);
MLPAPI int WINAPI MlpPageCount();
MLPAPI int WINAPI MlpGetPageRotation(int pageNum, int *rotate);
MLPAPI int WINAPI MlpGetPageBoundary(int pageNum, int kind, float *userUnit, float *left, float *bottom, float *right, float *top);
MLPAPI int WINAPI MlpGetPageRawBoundary(int pageNum, int kind, float *userUnit, float *left, float *bottom, float *right, float *top);
MLPAPI int WINAPI MlpGetPicturePixel(int pageNum, int *x, int *y);
MLPAPI int WINAPI MlpGetPicturePixelX(int pageNum);
MLPAPI int WINAPI MlpGetPicturePixelY(int pageNum);
MLPAPI int WINAPI MlpGetMetadata(unsigned char **metadata);
MLPAPI int WINAPI MlpGetCid0GlyphMode();
MLPAPI int WINAPI MlpPrintRestriction();

/*ݒ*/
MLPAPI int WINAPI MlpSetPicture(int opt, ...);
MLPAPI int WINAPI MlpSetPictureSize(int x, int y, int unit);
MLPAPI int WINAPI MlpSetPictureResolution(int dpi);
MLPAPI int WINAPI MlpSetPictureQuality(int quality);
MLPAPI int WINAPI MlpSetPicturePixelX(int x);
MLPAPI int WINAPI MlpSetPicturePixelY(int y);
MLPAPI int WINAPI MlpSetPicturePixelXY(int x, int y);
MLPAPI int WINAPI MlpSetCanvasSize(int x, int y);
MLPAPI int WINAPI MlpSetCanvasOrigin(int org);
MLPAPI int WINAPI MlpSetTiffCompress(int mode);
MLPAPI int WINAPI MlpSetEnableAntialis();
MLPAPI int WINAPI MlpSetDisableAntialis();
MLPAPI int WINAPI MlpSetFillPathAAEnable();
MLPAPI int WINAPI MlpSetFillPathAADisable();
MLPAPI int WINAPI MlpSetCid0GlyphMode(int mode);

/*F*/
MLPAPI int WINAPI MlpSetPictureRGB();
MLPAPI int WINAPI MlpSetPictureCMYK();
MLPAPI int WINAPI MlpSetPictureGray();
MLPAPI int WINAPI MlpSetPictureBW();
MLPAPI int WINAPI MlpSetPictureDither();
MLPAPI int WINAPI MlpSetPictureFaxG3();
MLPAPI int WINAPI MlpSetPictureFaxG4();

/*J[vt@C*/
MLPAPI int WINAPI MlpUseCMS();
MLPAPI int WINAPI MlpUnuseCMS();
MLPAPI int WINAPI MlpSetRGBProfileW(const wchar_t *fileName);
MLPAPI int WINAPI MlpSetRGBProfileA(const char *fileName);
MLPAPI int WINAPI MlpSetCMYKProfileW(const wchar_t *fileName);
MLPAPI int WINAPI MlpSetCMYKProfileA(const char *fileName);
MLPAPI int WINAPI MlpSetGrayProfileW(const wchar_t *fileName);
MLPAPI int WINAPI MlpSetGrayProfileA(const char *fileName);

/*pX[h*/
MLPAPI int WINAPI MlpValidateOwnerPasswordA(const char *pass);
MLPAPI int WINAPI MlpValidateOwnerPasswordW(const wchar_t *pass);
MLPAPI int WINAPI MlpValidateUserPasswordA(const char *pass);
MLPAPI int WINAPI MlpValidateUserPasswordW(const wchar_t *pass);

/*R[obN*/
MLPAPI int WINAPI MlpSetCallbackFunc(int mode, int opt, void *function);

/*tHg*/
MLPAPI int WINAPI MlpSetDefaultFontW(const wchar_t *defaultFont);
MLPAPI int WINAPI MlpSetDefaultFontA(const char *defaultFont);
MLPAPI int WINAPI MlpSetAlternateFontA(const char *org, const char *alt, int always);
MLPAPI int WINAPI MlpSetAlternateFont2W(const wchar_t *org, const wchar_t *alt, const wchar_t *weight, const wchar_t *style, int always, int replace);
MLPAPI int WINAPI MlpSetAlternateFont2A(const char *org, const char *alt, const char *weight, const char *style, int always, int replace);
MLPAPI int WINAPI MlpSetAlternateFontExW(const wchar_t *org, const wchar_t *alt, int always, int replace, int replace_on_render2, int alt_bold, int alt_style, int alt_variant, int weight, int italic, Matrix *trm);
MLPAPI int WINAPI MlpSetAlternateFontExA(const char *org, const char *alt, int always, int replace, int replace_on_render2, int alt_bold, int alt_style, int alt_variant, int weight, int italic, Matrix *trm);

/*EH[^[}[N*/
MLPAPI int WINAPI MlpSetImageWatermarkW(const wchar_t *fileName, int x_position, int y_position, int z_position, float x_scale, float y_scale, float alpha);
MLPAPI int WINAPI MlpSetImageWatermarkA(const char *fileName, int x_position, int y_position, int z_position, float x_scale, float y_scale, float alpha);
MLPAPI int WINAPI MlpSetFillTextWatermarkW(const wchar_t *text, const wchar_t *fontName, int x_position, int y_position, int z_position, float fontSize, const wchar_t *colorName, float alpha);
MLPAPI int WINAPI MlpSetFillTextWatermarkA(const char *text, const char *fontName, int x_position, int y_position, int z_position, float fontSize, const char *colorName, float alpha);
MLPAPI int WINAPI MlpSetStrokeTextWatermarkW(const wchar_t *text, const wchar_t *fontName, int x_position, int y_position, int z_position, float fontSize, const wchar_t *colorName, float alpha);
MLPAPI int WINAPI MlpSetStrokeTextWatermarkA(const char *text, char const *fontName, int x_position, int y_position, int z_position, float fontSize, const char *colorName, float alpha);
MLPAPI int WINAPI MlpClearWatermarkData();

/*摜*/
MLPAPI int WINAPI MlpCreatePictW(int pageNumber, const wchar_t *outputFilePath);
MLPAPI int WINAPI MlpCreatePictA(int pageNumber, const char *outputFilePath);
MLPAPI int WINAPI MlpCreatePictDataW(int pageNumber, const wchar_t *outputFormat, unsigned int *len, unsigned char **datap);
MLPAPI int WINAPI MlpCreatePictDataA(int pageNumber, const char *outputFormat, unsigned int *len, unsigned char **datap);
MLPAPI int WINAPI MlpPageToPictW(int pageNumber, int dpi, int quality, const wchar_t *outputFilePath);
MLPAPI int WINAPI MlpPageToPictA(int pageNumber, int dpi, int quality, const char *outputFilePath);
MLPAPI int WINAPI MlpConvertToTiffW(const wchar_t *outputFilePath);
MLPAPI int WINAPI MlpConvertToTiffA(const char *outputFilePath);
MLPAPI int WINAPI MlpCreateTiffRangeW(int startPageNumber, int endPageNumber, const wchar_t *outputFilePath);
MLPAPI int WINAPI MlpCreateTiffRangeA(int startPageNumber, int endPageNumber, const char *outputFilePath);
MLPAPI int WINAPI MlpCreateTiffMultiW(const wchar_t *pageList, const wchar_t *outputFilePath);
MLPAPI int WINAPI MlpCreateTiffMultiA(const char *pageList, const char *outputFilePath);
MLPAPI int WINAPI MlpRangeToTiffW(int startPageNumber, int endPageNumber, int dpi, const wchar_t *outputFilePath);
MLPAPI int WINAPI MlpRangeToTiffA(int startPageNumber, int endPageNumber, int dpi, const char *outputFilePath);
MLPAPI int WINAPI MlpMultiPageToTiffW(const wchar_t *pageList, int dpi, const wchar_t *outputFilePath);
MLPAPI int WINAPI MlpMultiPageToTiffA(const char *pageList, int dpi, const char *outputFilePath);

/*X^CYhPDF*/
MLPAPI int __stdcall MlpCreatePDFW(int pageNum, int img_dpi, int img_quality, wchar_t *outputFilePath);
MLPAPI int __stdcall MlpCreatePDFA(int pageNum, int img_dpi, int img_quality, char *outputFilePath);
MLPAPI int __stdcall MlpCreatePDFFileW(int img_dpi, int img_quality, wchar_t *outputFilePath);
MLPAPI int __stdcall MlpCreatePDFFileA(int img_dpi, int img_quality, char *outputFilePath);
MLPAPI int __stdcall MlpCreatePDFArrayW(int *arry_page, int arry_len, int img_dpi, int img_quality, wchar_t *outputFilePpath);
MLPAPI int __stdcall MlpCreatePDFArrayA(int *arry_page, int arry_len, int img_dpi, int img_quality, char *outputFilePpath);
MLPAPI int __stdcall MlpAddToPDFW(int pageNum, int img_dpi, int img_quality, wchar_t *outputFilePath);
MLPAPI int __stdcall MlpAddToPDFA(int pageNum, int img_dpi, int img_quality, char *outputFilePath);

/*摜f[^*/
MLPAPI int WINAPI MlpCreatePictBufPage(int pageNumber, unsigned char **pixels, int *width, int *height, int *nOfColors);
MLPAPI int WINAPI MlpCreatePictBufPageRange(int firstPageNumber, int lastPageNumber);
MLPAPI int WINAPI MlpCreatePictBufPageArray(int PageNumberArray[], int length);
MLPAPI int WINAPI MlpCreatePictMem(int pageNumber);

/*摜f[^擾ƊJ*/
MLPAPI int WINAPI MlpGetPictFromMem(unsigned char **pixels, int *width, int *height, int *nOfColors);
MLPAPI int WINAPI MlpGetPictFromMemIndex(int index, unsigned char **pixels, int *width, int *height, int *nOfColors, int *pageNumber);
MLPAPI int WINAPI MlpGetPictFromMemPage(int pageNumber, unsigned char **pixels, int *width, int *height, int *nOfColors);
MLPAPI int WINAPI MlpFreePictMem();

/*C[(OCG)*/
MLPAPI int WINAPI MlpGetOcgCount();
MLPAPI int WINAPI MlpGetOcgUsage(MlpOcgUsage *data[]);
MLPAPI int WINAPI MlpSetOcgState(MlpOcgData data[]);
MLPAPI int WINAPI MlpSetOcgStateU(MlpOcgUsage data[]);

/*Text Widget*/
MLPAPI int WINAPI MlpSetTextWidgetMultilineFontSize(float size);
MLPAPI float WINAPI MlpGetTextWidgetMultilineFontSize();
MLPAPI int WINAPI MlpSetTextWidgetMultilineUseLastSize(int use);
MLPAPI int WINAPI MlpGetTextWidgetMultilineUseLastSize();

/* pl */
MLPAPI int WINAPI MlpCreatePanel(int width, int height, int colorspace);
MLPAPI int WINAPI MlpClearPanel();
MLPAPI int WINAPI MlpFreePanel();
MLPAPI int WINAPI MlpPanelToFileA(const char *filePath);
MLPAPI int WINAPI MlpPanelToFileW(const wchar_t *filePath);
MLPAPI int WINAPI MlpMemPictToPanel(int x, int y, float alpha);
MLPAPI int WINAPI MlpMemPictToPanelBBox(int panel_xpos, int panel_ypos, float alpha, int bbox_xpos, int bbox_ypos, int bbox_width, int bbox_height);
MLPAPI int WINAPI MlpPaintRectToPanel(int xpos, int ypos, int width, int height, int lineWidth, unsigned char color[]);
MLPAPI int WINAPI MlpPaintRectToPanel2A(int xpos, int ypos, int width, int height, int lineWidth, char *color);
MLPAPI int WINAPI MlpPaintRectToPanel2W(int xpos, int ypos, int width, int height, int lineWidth, wchar_t *color);

/*X^v*/
MLPAPI int WINAPI MlpSetStampFileA(char *filePath);
MLPAPI int WINAPI MlpSetStampFileW(wchar_t *filePath);
MLPAPI int WINAPI MlpSetStampDataA(char* data, unsigned int length);
MLPAPI int WINAPI MlpSetStampDataW(wchar_t* data, unsigned int length);
MLPAPI int WINAPI MlpPaintStamp();
MLPAPI int WINAPI MlpPaintStampFileA(char *filePath);
MLPAPI int WINAPI MlpPaintStampFileW(wchar_t *filePath);
MLPAPI int WINAPI MlpPaintStampDataA(char* data, unsigned int length);
MLPAPI int WINAPI MlpPaintStampDataW(wchar_t* data, unsigned int length);
MLPAPI int WINAPI MlpPaintStampNameA(char *id);
MLPAPI int WINAPI MlpPaintStampNameW(wchar_t *id);
MLPAPI int WINAPI MlpPaintStampNamePosA(char *id, float x_pos, float y_pos);
MLPAPI int WINAPI MlpPaintStampNamePosW(wchar_t *id, float x_pos, float y_pos);
MLPAPI int WINAPI MlpClearStampBoundary();
MLPAPI int WINAPI MlpGetStampBoundary(float *x_pos, float *y_pos, float *width, float *height);

/*PDFf[^*/
MLPAPI int WINAPI MlpRemoveMetadata();
MLPAPI int WINAPI MlpSavePDFA(char *filePath);
MLPAPI int WINAPI MlpSavePDFW(wchar_t *filePath);


#ifdef	__cplusplus
}
#endif
