﻿//
// Stamper Sample
//
// Copyright (c) 2020-2022 株式会社トラスト・ソフトウェア・システム
//

using System;
using PDFTools.PDFStructure;

namespace Stamp
{
	class Stamp
	{
		static void Main(string[] args)
		{
			//インスタンス生成
			Stamper stmp = new Stamper();

			//初期化
			if (stmp.Initialize("0-0372-5WERR0W0H22E") != 0)
			{
				Console.WriteLine("ERROR: Initialize");
				Environment.Exit(1);
			}
			stmp.ShowLicenseInfo();

			//初期化ファイル
			if (stmp.LoadInitFile("../../../../xml/init.xml") != 0)
			{
				Console.WriteLine("ERROR: LoadInitFile");
			}

			//オープン
			if (stmp.OpenDoc("../../../../../doc/PDF Stamper 説明書.pdf", null) != 0)
			{
				Console.WriteLine("ERROR: LoadInitFile");
				goto end_proc;
			}

			//スタンプ
			int res = 0;
			res = stmp.PaintStampName("Tanaka");
//			res = stmp.PaintStampName("Suzuki");
//			res = stmp.PaintStampName("Image");
//			res = stmp.PaintStampName("Tesigawara");
//			res = stmp.PaintStampName("Kakuin");
//			res = stmp.PaintStampName("Kenin");
//			res = stmp.PaintStampName("Maruin");
// 			res = stmp.PaintStampName("Moji");
            if (res < 0)
			{
				Console.WriteLine("ERROR: PaintStampName");
			}

			//PDF出力
			stmp.SavePDF("out.pdf");

			//画像出力
			stmp.CreatePict(1, "out.png");

			//クローズ
			stmp.CloseDoc();

			//終了
			end_proc:
			stmp.Uninitialize();
		}
	}
}

