﻿//
// Stamper Sample
//
// Copyright (c) 2020-2022 株式会社トラスト・ソフトウェア・システム
//

using System;
using PDFTools.PDFStructure;

namespace Stamp
{
   class Stamp
	{
 
		static string xml = @"
<?xml version=""1.0"" encoding=""utf-8"" ?>
<pdfstamp xmlns = ""http://www.trustss.co.jp/2019/PDFStamp/"" >
	< stamp name=""Suzuki"" pos=""10 50"" layer=""annot"" alpha=""1"" blendmode=""Normal"" page=""1""
		creation=""2020/4/1 9:0:0"" creator=""サンプル株式会社"" subject=""承認済み"" >
		<text value = ""鈴木"" font-name=""MS Gothic"" color=""0 .75 .75 0"" wmode=""vertical""
			char-space="".3"" expand=""1.2 .5"" font-size=""10.5"" />
	<border color = ""0 .75 .75 0"" corner=""max"" width=""0.5"" clip=""true"" />
	</stamp>
</pdfstamp>";

		static void Main(string[] args)
		{

			//インスタンス生成
			Stamper stmp = new Stamper();

			//初期化
			if (stmp.Initialize("ライセンスキー") != 0)
			{
				Console.WriteLine("ERROR: Initialize");
				Environment.Exit(1);
			}
			stmp.ShowLicenseInfo();

#if false
			//初期化ファイル
			if (stmp.LoadInitFile("../../../../xml/init.xml") != 0)
			{
				Console.WriteLine("ERROR: LoadInitFile");
			}
#endif

			//オープン
			if (stmp.OpenDoc("in.pdf", null) != 0)
			{
				Console.WriteLine("ERROR: LoadInitFile");
				goto end_proc;
			}

			//スタンプ
			int res;
#if false
			stmp.SetStampFile("../../../../xml/stamp.xml");
//			res = stmp.PaintStamp();
			res = stmp.PaintStampName("Tanaka");
//			res = stmp.PaintStampName("Suzuki");
//			res = stmp.PaintStampName("Image");
//			res = stmp.PaintStampName("Tesigawara");
//			res = stmp.PaintStampName("Kakuin");
//			res = stmp.PaintStampName("Kenin");
//			res = stmp.PaintStampName("Maruin");
//			res = stmp.PaintStampName("Moji");
			if(res < 0)
			{
				Console.WriteLine($"ERROR: PaintStampName({res})");
			}
#else
			res = stmp.PaintStampFile("../../../../xml/tanaka.xml");
//			res = stmp.PaintStampData(xml);
			if(res < 0)
			{
				Console.WriteLine($"ERROR: PaintStamp({res})");
			}
#endif

			//PDF出力
			stmp.SavePDF("out.pdf");

			//画像出力
			stmp.CreatePict(1, "out.png");

			//クローズ
			stmp.CloseDoc();

			//終了
			end_proc:
			stmp.Uninitialize();
		}
	}
}
