/*
**	Stamp
**
** Copyright (C) 2020-2022 ЃgXgE\tgEFAEVXe
*/

#include <stdio.h>
#include <tchar.h>
#include "PdfStamper.h"

#pragma comment(lib,"PdfStructure.lib")

TCHAR *xml = 
TEXT("<?xml version=\"1.0\" ?>")
TEXT("<pdfstamp xmlns=\"http://www.trustss.co.jp/2019/PDFStamp/\">")
TEXT(	"<stamp name=\"Suzuki\" pos=\"10 50\" layer=\"annotation\" alpha=\"1\" blendmode=\"Normal\" page=\"1\" ")
TEXT(		"creation=\"2020/4/1 9:0:0\" modification=\"2020/4/1 9:0:0\" creator=\"Tv\" subject=\"Fς\" >")
TEXT(		"<text value=\"\" font-name=\"MS Gothic\" color=\"0 .75 .75 0\" wmode=\"vertical\" ")
TEXT(			"char-space=\"0.3\" expand=\"1.2 .5\" font-size=\"10.5\" />")
TEXT(		"<border color=\"0 .75 .75 0\" corner=\"max\" width=\"0.5\" clip=\"true\" />")
TEXT(	"</stamp>")
TEXT("</pdfstamp>");

int main()
{
	int res;

	/**/
	res = MlpInitialize(TEXT("CZXL["));
	if (res) {
		fprintf(stderr, "ERROR: MlpInitialize\n");
		return 1;
	}

#if 0
	/*t@C*/
	res = MlpLoadInitFile(TEXT("../../xml/init.xml"));
	if (res) {
		fprintf(stderr, "ERROR: MlpLoadInitFile\n");
		return 2;
	}
#endif

	/*I[v*/
	res = MlpOpenDoc(TEXT("in.pdf"), NULL);
	if (res) {
		fprintf(stderr, "ERROR: MlpOpenDoc\n");
		return 3;
	}

	/*X^v*/
#if 0
	res = MlpSetStampFile(TEXT("../../xml/stamp.xml"));
//	res = MlpPaintStamp();
	res = MlpPaintStampName(TEXT("Tanaka"));
//	res = MlpPaintStampName(TEXT("Suzuki"));
//	res = MlpPaintStampName(TEXT("Image"));
//	res = MlpPaintStampName(TEXT("Tesigawara"));
//	res = MlpPaintStampName(TEXT("Kakuin"));
//	res = MlpPaintStampName(TEXT("Kenin"));
//	res = MlpPaintStampName(TEXT("Maruin"));
//	res = MlpPaintStampName(TEXT("Moji"));
	if (res) {
		fprintf(stderr, "ERROR: MlpPaintStampName(%d)\n", res);
	}
#else
	res = MlpPaintStampFile(TEXT("../../xml/Tanaka.xml"));
//	res = MlpPaintStampData(xml, (unsigned int)_tcslen(xml));
	if (res < 0) {
		fprintf(stderr, "ERROR: MlpPaintStampFile(%d)\n", res);
	}
#endif

	/*PDFo*/
	res = MlpSavePDF(TEXT("out.pdf"));

	/*摜o*/
	MlpCreatePict(1, TEXT("out.png"));

	/*N[Y*/
	MlpCloseDoc();

	/*I*/
	MlpUninitialize();

	return 0;
}
